--[[
	Turn-In Mod
	version 1.1
	Authored by Ian Friedman
		Sabindeus of Skullcrusher (Alliance)
	The repeatable quest turn in automating machine.
]]

local TI_questnum;
local TI_rewardnum;
local TI_slashtable;
local TI_status;
local TI_gossipclosed;

local TI_events = {
	"GOSSIP_SHOW",
	"GOSSIP_CLOSED",
	"QUEST_DETAIL",
	"QUEST_COMPLETE",
	"QUEST_PROGRESS",
	"QUEST_GREETING"
};

function TI_message(msg)
	DEFAULT_CHAT_FRAME:AddMessage(msg);
end

function TI_OnLoad()
	SlashCmdList["TI"]=TI_SlashCmdHandler;
	SLASH_TI1="/turnin"
	TI_questnum = 1;
	TI_rewardnum = 0;
	TI_message("Turn-In Mod loaded");
	TI_slashtable = {};
	TI_status = false;
	TI_gossipclosed = false;
end


function TI_LoadEvents() 
	for k,v in pairs(TI_events) do 
		TurnIn:RegisterEvent(v);
	end
end

function TI_UnloadEvents() 
	for k,v in pairs(TI_events) do 
		TurnIn:UnregisterEvent(v);
	end
end

function TI_SlashCmdHandler(cmd)
	cmdlist = split(cmd, " ");
	if(cmdlist[1] == "on") then
		TI_status = true;
		TI_LoadEvents();
		TI_message("Turn-In Mod On");
	end
	if(cmdlist[1] == "off") then
		TI_status = false;
		TI_UnloadEvents();
		TI_message("Turn-In Mod Off");
	end
	if(cmdlist[1] == "toggle") then
		if(TI_status) then
			TI_status = false;
			TI_UnloadEvents();
			TI_message("Turn-In Mod Off");
		else
			TI_status = true;
			TI_LoadEvents();
			TI_message("Turn-In Mod On");
		end
	end
	if(cmdlist[1] == "status") then
		if(TI_status) then
			TI_message("Turn-In Mod On");
		else
			TI_message("Turn-In Mod Off");
		end
		TI_message(string.format("Quest Number set to %d", TI_questnum));
		TI_message(string.format("Reward Number set to %d", TI_rewardnum));
	end
	if(cmdlist[1] == "qnum") then
		newqnum = tonumber(cmdlist[2]);
		TI_questnum = newqnum;
		TI_message(string.format("Quest Number set to %d", TI_questnum));
	end
	if(cmdlist[1] == "rnum") then
		newrnum = tonumber(cmdlist[2]);
		TI_rewardnum = newrnum;
		TI_message(string.format("Reward Number set to %d", TI_rewardnum));
	end
end


function TI_OnEvent(event)
	if(event == "QUEST_GREETING") then
		SelectAvailableQuest(TI_questnum);
	end
	if(event == "GOSSIP_SHOW") then
		SelectGossipAvailableQuest(TI_questnum);
	end
	if(event == "GOSSIP_CLOSED") then
		TI_gossipclosed = true;
	end
	if(event == "QUEST_COMPLETE") then
		GetQuestReward(TI_rewardnum);
	end
	if(event == "QUEST_PROGRESS") then
		CompleteQuest();
	end
end

function TI_OnUpdate(dt)
	if(TI_status) then
		if(TI_gossipclosed) then
			TI_gossipclosed = false;
			CompleteQuest();
		end
	end
end

--[[	This split function shamelessly pirated from the Sea library. 
		Credit goes to Thott and Legorol and the whole Cosmos team... I only stole it to remove dependencies.
		Some people don't like to have to install libraries. :/
	]]
function split ( text, separator) 
		local value;
    	local init, mstart, mend = 1;
		local t, oldn = TI_slashtable, 0;
		
		if ( not t ) then
			t = {};
		else
			oldn = table.getn(t);
			table.setn(t, 0);
		end
				
    	repeat
			mstart, mend, value = string.find(text, "([^"..separator.."]+)", init);
			if ( value ) then
				table.insert(t, value)
				init = mend + 1;
			end
    	until not value;
		
		for i = table.getn(t)+1, oldn do
			t[i] = nil;
		end
		
		return t;
	end;